/*                   B W F L A T . H
 * Bruce R. Julian, USGS Menlo Park Calif., Dec 15 1983
 */
#ifndef BWAVE_H
#define BWAVE_H

#define register		/* No register variables */

#include "stdtyp.h"

#define MAXLYR	20		/* Max. layers per submodel	*/
#define MAXSM	2		/* Max. submodels per model	*/
#define REAL	double
#define UNDEF	100000.		/* Undefined value		*/

/* Data types */
typedef struct {		/* Submodel			*/
	int	nl;		/* No. of layers		*/
	float	h[MAXLYR];	/* Layer thicknesses		*/
	float	v[MAXLYR];	/* Wave speeds			*/
	float	s[MAXLYR];	/* Wave slownesses		*/
	float	s2[MAXLYR];	/* Squares of wave slownesses	*/
	int	lmax[MAXLYR];	/* Fastest layer above		*/
	float	var_s[MAXLYR];	/* Variance of slowness		*/
	float	a[MAXLYR];	/* Correllation distance	*/
} SUBMDL;

typedef struct {		/* Model			*/
	int	nsm;		/* No. of submodels		*/
	SUBMDL	sm[MAXSM];
} MODEL;

/* External functions */
tbool	bwave();
void	getmdl();
#endif
