/*                            C M D _ O P T . H
 * Include file for command-line argument processing
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */
#ifndef CMDOPT_H
#define CMDOPT_H
#include <local/stdtyp.h>

#ifndef DIM
#define DIM(x) (sizeof(x)/sizeof((x)[0]))	/* Dimension of array	*/
#endif DIM

struct command {
	int  (*c_func)();	/* Function to be called for option	*/
	char *c_name;		/* Name of option in argument list	*/
	char *c_args;		/* Args (printed for documentation)	*/
	char *c_comment;	/* Printed out for documentation	*/
};

char		*aarg();
struct command	*findname();
int		isnarg();
double		narg();
char		*peekarg();
void		prt_help();
void		prt_doc();

int	eargc;			/* Copy of argc			*/
char	**eargv;		/* Copy of argv			*/
int	iarg;			/* Argument index		*/
int	ncmd;			/* No. of elements in cmd[]	*/
char	*progname;		/* For error messages		*/

#define PROCESS_OPTS { \
	progname = argv[0]; \
	eargc    = argc; \
	eargv    = argv; \
	ncmd	 = DIM(cmd); \
	for (iarg=1; iarg<eargc && eargv[iarg][0]=='-'; iarg++) \
		XEQCMD(eargv[iarg]); \
}
#define XEQCMD(s)	(*findname(s)->c_func)()
#endif CMDOPT_H
