/*             D A T E _ T I M E . H
 * Include file for calendar and time routines
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */
#ifndef DATETIME_H
#define DATETIME_H

/*  #define	BASEJDN		2440588			/* 1 January 1970	*/
#define	BASEJDN		2341973			/* 1 January 1700	*/

/* Calendar codes */
#define	GREGORIAN	1			/* Modern calendar	*/
#define	JULIAN		0			/* Old-style calendar	*/

/* Time intervals */
#define	SECOND		1
#define	MINUTE		(60*SECOND)
#define	HOUR		(60*MINUTE)
#define	DAY		(24*HOUR)
#define	WEEK		(7*DAY)
#define	YEAR		(365*DAY)
#define	LEAPYEAR	(366*DAY)
#define	DMILLISEC	(1e-3*SECOND)
#define	DMICROSEC	(1e-6*SECOND)
#define	DNANOSEC	(1e-9*SECOND)

/* Data types */
typedef double	TIME;

/* External functions */
int	ckdate();
void	date();
bool	isleap();
long	jdn();
void	mnday();
TIME	timvar();
int	yrday();
#endif DATETIME_H
