/*                  F I T . H
 * Include file for data-fitting routines
 * Bruce R. Julian, USGS Menlo Park Calif., Dec 15 1983
 */
#ifndef FIT_H
#define FIT_H
#include "stdtyp.h"

#define register		/* No register variables */

/* Data types */
typedef struct {		/* Fit problem			*/
	int	n_var;		/* No. of unknowns		*/
	int	n_con;		/* No. of constraints		*/
	FLOAT	*nrmcof;	/* Normal equation coefficients	*/
	FLOAT	*nrmrhs;	/* Right-hand side		*/
} FITPROB;

/* External functions */
FITPROB	*fitinit(),	*dfitinit();
void	fiteqn(),	dfiteqn();
void	fitcon(),	dfitcon();
int	fitslv(),	dfitslv();
void	fitclose(),	dfitclose();
#endif
