/*
 *                           m o d e l 3 d . h
 */
#ifndef MODEL3D_H
#define MODEL3D_H
#ifndef NULL
#define NULL 0
#endif NULL

typedef struct {
	struct lim {
		float	lat0, lon0, rot;
		int	nx, ny, nz;
	} limits;
	float	*xgrid;		/* [0..nx-1]				*/
	float	*ygrid;		/* [0..ny-1]				*/
	float	*zgrid;		/* [0..nz-1]				*/
	float	***s;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sx;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sy;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sz;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sxy;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sxz;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***syz;		/* [0..nx-1][0..ny-1][0..nz-1]		*/
	float	***sxyz;	/* [0..nx-1][0..ny-1][0..nz-1]		*/
} MODEL3D;

typedef struct {	/* A point within the earth			*/
	float	s,		/* Wave slowness			*/
		sx, sy, sz,	/* Spatial derivatives			*/
		sxx, syy, szz,	/* Second derivatives			*/
		sxy, sxz, syz;
} EPOINT;

void	free_mdl();
void	sder();
MODEL3D	*rdmdl();
#endif MODEL3D_H
