/*
 * USGS refraction-data formats
 */

/* K.DAT:  Recorder info. and shot list */
typedef struct {
	short		nshot;
	short		nteam;
	short		nsamp;
	short		nrec;
	char		tit[80];
	short		month[30];
	short		iday[30];
	short		isp[30];
	short		jday[30];
	short		jhr[30];
	short		jmin[30];
	DEC_FLOAT	sec[30];
	short		ielev[30];
	short		isize[30];
	short		idtop[30];
	short		idbot[30];
	short		iwat[30];
	short		irock[30][5];
	short		iex[150];
} KDAT;

/* T.DAT:  Data */
typedef struct {
	short		msamp;		/* Number of samples per trace		*/
	short		mrec;		/* Number of traces, <= maxr		*/
	short		maxr;		/* Maximum # of traces			*/
	short		ihead[150][3];	/* ihead[i][0]: instrument unit #	*/
					/*   == -1 for unused records		*/
					/* ihead[i][1]: station site #		*/
					/* ihead[i][2]: reduced start time (s)	*/
					/*   Time of first data point =		*/
					/* tshot + rrdist[i]/vreduc + ihead[i][2]*/
	DEC_FLOAT	rrdist[150];	/* Shot-recorder distance (km)		*/
	char		title[80];
	short		nsrate;		/* Sampling interval (ms)		*/
	DEC_FLOAT	vreduc;		/* Reduction velocity (km/s)		*/
	short		atten[150];	/* Attenuator setting (dB)		*/
	DEC_FLOAT	az[150];	/* Shot-recorder azimuth (deg)		*/
	short		isp;		/* Shot point #				*/
	char		junk[5508];
} TDATHDR;

/* DKDAT: shot pts., attenuations, calibrations, etc. */
typedef struct {
	short		nshot;		/* No. of shots				*/
	short		nteam;
	short		msamp;
	short		nrec;
	char		tit[80];
	short		month[30];
	short		day[30];
	short		isp[30];	/* Shot point number			*/
	short		yrday[30];	/* Day of year				*/
	short		hour[30];	
	short		min[30];
	DEC_FLOAT	sec[30];
	short		year[30];
	short		size[30];	/* Shot sizes				*/
} DKDAT;
