/*                    S T A B L E . H
 * USGS Calnet seismograph-station tables
 */
#ifndef STABLE_H
#define STABLE_H

#define CSIZE   4

/* Structure describing open station file */
typedef struct stable {
        char            *idsta;         /* List of station codes        */
        unsigned        nsta;           /* No. of codes in idsta        */
        FILE            *fp;            /* Station file                 */
        long            offset;         /* Offset of info. of first sta.*/
} STABLE;

/* Structure containing info. for one station */
typedef struct stinfo {
	char	code[CSIZE];		/* Station code			*/
        float   lat, lon;		/* Coordinates			*/
        int     ielev;			/* Elevation (meters)		*/
        float   p_anom;			/* P-time anomaly		*/
#if 0
        float   s_anom;			/* S-time anomaly		*/
#endif 0
        float   dmag_anom;		/* Duration-magnitude anomaly	*/
        float   amag_anom;		/* Amplitude-magnitude anomaly	*/
        int     inst;			/* Instrument code		*/
        float   t_dflt;			/* Default period for amp_mag	*/
        float   cal_dflt;		/* Calibration for amp_mag	*/
} STINFO;

STABLE  *stopen();
void	stclose();
int	stindex();
int	stget();
#endif STABLE_H
