#ifndef lint
static char	rcsid[] = "$Header: atotime.c,v 1.1 88/10/17 13:57:53 julian Exp $";
#endif lint
/*
 * Bruce R. Julian, USGS Menlo Park, Calif, 28 Oct 1987
 */
#include <ctype.h>
#include <local/local.h>
#include <local/decode.h>
#include <local/date_time.h>

double		atof();
int		atoi();

/* Convert string to TIME */
/* "[cc]yymmddhhmmss.ss...[+-offset]" */
TIME
atotime(s)
	char	*s;
{
	int	yr, mo, da, hr, mn;
	double	se;
	char	*p;
	double	offset();

	/* Get year (twentieth century default) */
	for (p=s; isdigit(*p); p++)
		;
	switch (p - s) {
	case 14:
		yr = DECODE(s, 4, atoi);
		s += 2;
		break;
	case 12:
		yr = 1900 + DECODE(s, 2, atoi);
		break;
	default:
		return 0.;
	}

	/* Get month, day, hour, minute, second */
	mo = DECODE(s+ 2, 2, atoi);
	da = DECODE(s+ 4, 2, atoi);
	hr = DECODE(s+ 6, 2, atoi);
	mn = DECODE(s+ 8, 2, atoi);
	se = atof  (s+10);

	/* Skip to end of seconds field */
	s += 12;
	if (*s == '.')
		s++;
	while(isdigit(*s))
		s++;

	return timvar(yr, mo, da, hr, mn, se, GREGORIAN) + offset(s);
}

static double
offset(s)
	char	*s;
{
	double	sign, x, offset;

	switch (*s) {
	case '\0':	return 0.;
	case '+':	sign = 1.;	break;
	case '-':	sign = -1.;	break;
	default:
		return 0.;
	}
	s++;
	offset = 0.;
	while (isdigit(*s) || *s == '.') {
		x = atof(s);
		while (isdigit(*s))	s++;
		if (*s == '.')		s++;
		while (isdigit(*s))	s++;
		switch (*s) {
		case 'd': case 'D': x *= DAY	; break;
		case 'h': case 'H': x *= HOUR	; break;
		case 'm': case 'M': x *= MINUTE	; break;
		case 's': case 'S': x *= SECOND	; break;
		default:
			return 0.;
		}
		s++;
		offset += x;
	}
	return sign*offset;
}
