#ifndef lint
static char rcsid[] = "$Header: bcuint.c,v 1.2 89/01/21 16:15:27 julian Locked $";
#endif lint
/*
 * Bi-cubic interpolation
 */
#include <local/cuint.h>

void
bcuint(c, d1, d2, x, y, p)
	float	**c;		/* [0..4][0..4]Coefficients from bcucof()*/
	float	d1, d2;		/* Interval lengths			*/
	float	x, y;		/* Scaled independent variables		*/
	PT2	*p;		/* Interpolated value			*/
{
static	int	i;		/* Dummy loop index			*/
static	float	*r;		/* Row of matrix c			*/

#undef OLD
#ifdef OLD
	p->f = p->fx = p->fy = p->fxx = p->fxy = p->fyy = 0.0;

	for (i=3; i>=0; --i) {
#else OLD
	p->fx = p->fxx = p->fxy = 0.0;
	r = c[3];
	p->f	= ((r[3]*y + r[2])*y + r[1])*y + r[0];
	p->fy	= (3.0*r[3]*y + 2.0*r[2])*y + r[1];
	p->fyy	=  6.0*r[3]*y + 2.0*r[2];

	for (i=2; i>=0; --i) {
#endif OLD
		r = c[i];
		p->fxx	= (p->fxx)*x + 2.0*(p->fx);
		p->fxy	= (p->fxy)*x + (p->fy);
		p->fx	= (p->fx) *x + (p->f);
		p->f	= (p->f)  *x + ((r[3]*y + r[2])*y + r[1])*y + r[0];
		p->fy	= (p->fy) *x + (3.0*r[3]*y + 2.0*r[2])*y + r[1];
		p->fyy	= (p->fyy)*x + 6.0*r[3]*y + 2.0*r[2];
	}
	p->fx /= d1;
	p->fy /= d2;
	p->fxx /= (d1*d1);
	p->fxy /= (d1*d2);
	p->fyy /= (d2*d2);
}

#ifdef TEST
char	*progname = "test_bcuint";

float	**fmatrix();

main()
{
	float	**c;
	float	f[4], f1[4], f2[4], f12[4];
	int	i;
	float	x, y;
	PT2	p;

	/* Read function and derivative values */
	c = fmatrix(0, 3, 0, 3);
	if (scanf("%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f",
		f  , f1  , f2  , f12  ,
		f+1, f1+1, f2+1, f12+1,
		f+2, f1+2, f2+2, f12+2,
		f+3, f1+3, f2+3, f12+3
	) != 16)
		error("Can't read function and derivative values");

	/* Compute and print polynomial coefficients */
	bcucof(f-1, f1-1, f2-1, f12-1, 1.0, 1.0, c);
	for (i=0; i<4; i++) {
		float	*r=c[i];	/* ith row of c[0..3][0..3]	*/
		printf("%g\t%g\t%g\t%g\n", r[0], r[1], r[2], r[3]);
	}

	/* Loop, reading coordinates, computing and printing interpolated values */
	while (scanf("%f%f", &x, &y) == 2) {
		bcuint(c, 1.0, 1.0, x, y, &p);
		printf("%f\n%f\t%f\n%f\t%f\t%f\n",
			p.f, p.fx, p.fy, p.fxx, p.fxy, p.fyy);
	}
}
#endif TEST
