char	*emalloc();

/*
 * Allocate a float matrix m[rl..rh][cl..ch] that points to the
 * standard C matrix a[nrow][ncol], where nrow = rh-rl+1 and ncol = ch-cl+1
 */
float**
cvfmatrix(a, rl, rh, cl, ch)
	float	*a;
	int	rl, rh;
	int	cl, ch;
{
	int	i, j;
	int	nrow, ncol;
	float	**m;

	nrow = rh - rl + 1;
	ncol = ch - cl + 1;

	/* Allocate space for pointers to rows */
	m = (float**)emalloc((unsigned)(nrow)*sizeof(float*)) - rl;
	for (i=0,j=rl; i<=nrow-1; i++,j++)
		m[j] = a + ncol*i - cl;
	return m;
}

/*
 * Free a matrix allocated by cvfmatrix()
 */
/*ARGSUSED*/
void
fcvfmatrix(b, rl, rh, cl, ch)
	float	**b;
	int	rl, rh;
	int	cl, ch;
{
	free((char*)(b+rl));
}
