/*
 * Sort eigenvalues and eigenvectors into descending order
 */
eigsrt(d, v, n)
	float	*d;	/* [1..n] Eigenvalues				*/
	float	**v;	/* [1..n][1..n]Eigenvectors (stored columnwise!)*/
	int	n;	/* No. of eigenvalues, eigenvectors		*/
{
	int	i, j, k;
	float	p;

	for (i=1; i<=n-1; i++) {
		p = d[k=i];
		for (j=i+1; j<=n; j++)
			if (d[j] >= p)
				p = d[k=j];
		if (k != i) {
			d[k] = d[i];
			d[i] = p;
			for (j=1; j<=n; j++) {
				p = v[j][i];
				v[j][i] = v[j][k];
				v[j][k] = p;
			}
		}
	}
}
