#ifndef lint
static char rcsid[]="$Header: error.c,v 1.4 90/04/08 12:32:22 julian Exp $";
#endif
/*
 * Report error, optionally die
 * Bruce R. Julian, USGS Menlo Park, Calif. 14 Dec 1983
 */
#include <stdio.h>
#include <local/stdtyp.h>
#include <varargs.h>

extern	int	sys_nerr;
extern	int	errbase, nerr;
extern	char	*sys_errlist[], *q_errlist[];
extern	int	errno;
extern	char	*progname;

void	exit();
/*:: char	*sprintf();*/

/* Return error message */
char
*ermsg(ier)
	int	ier;
{
static	char	s[12];

	if (ier == 0)
		return (NULL);
	if (ier > 0 && ier < sys_nerr)
		return (sys_errlist[ier]);
	ier -= errbase;
	if (ier > 0 && ier < nerr)
		return (q_errlist[ier]);
	else
		return (sprintf(s, "Error %d", errbase+ier));
}

/* Print error message */
/*VARARGS*/
static void
msg(args)
	va_list	args;
{
	char	*fmt;			/* Format string		*/
	char	*p;

	if (progname)
		(void)fprintf(stderr, "%s: ", progname);
	fmt = va_arg(args, char*);
	_doprnt(fmt, args, stderr);
	if ((p = ermsg(errno)) != NULL)
		(void)fprintf(stderr, " (%s)", p);
	(void)fprintf(stderr, "\n");
}

/* Print error message but don't die */
/*VARARGS*/
void
report(va_alist)
	va_dcl
{
	va_list	args;

	va_start(args);
	msg(args);
	va_end(args);
}

/* Print error message and die */
/*VARARGS*/
void
error(va_alist)
	va_dcl
{
	va_list	args;

	va_start(args);
	msg(args);
	va_end(args);
	exit(1);
}
