#ifndef lint
static char rcsid[]="$Header: euler.c,v 1.2 88/10/17 11:16:21 julian Exp $";
#endif
/*
 * Transformation matrix for coordinate rotation
 *  Specified in terms of the Eulerian angles.
 *  Conventions used are those of
 *  Goldstein, Classical Mechanics, 1959, chapter 4.
 */
#include <math.h>
#include <local/mathconst.h>

void
euler(phi, theta, psi, a)
	double	phi, theta, psi;
	float	a[3][3];
{
	double	cf, sf, ct, st, cs, ss, ctcf, ctsf;

	cf = cos(phi);		sf = sin(phi);
	ct = cos(theta);	st = sin(theta);
	cs = cos(psi);		ss = sin(psi);
	ctsf = ct*sf;
	ctcf = ct*cf;
	a[X][X] = cs*cf-ctsf*ss;
	a[X][Y] = cs*sf+ctcf*ss;
	a[X][Z] = ss*st;
	a[Y][X] = -ss*cf-ctsf*cs;
	a[Y][Y] = -ss*sf+ctcf*cs;
	a[Y][Z] = cs*st;
	a[Z][X] = st*sf;
	a[Z][Y] = -st*cf;
	a[Z][Z] = ct;
}
