#ifndef lint
static char rcsid[] = "$Header: falsem.c,v 1.2 92/05/25 06:10:10 julian Exp $";
#endif lint
#include <stdio.h>
#include <local/local.h>
#include <local/qerr.h>

	void	report();	/* -lq (error.c)			*/

/*
 * Find root of a scalar function of one real variable.
 * Modified method of false position,
 * as suggested in last paragraph of setion 4.5 of
 * R. W. Hamming, Numerical Methods for Scientists
 * and Engineers, 2nd ed., McGraw-Hill, 1973.
 */

int
falsem(f, a, b, e, n, x)
	double	(*f)();		/* Function				*/
	double	a, b;		/* Limits of x interval 		*/
	double	e;		/* Tolerance				*/
	int	n;		/* Iteration limit			*/
	double	*x;		/* Root					*/

{
extern	int	errno;
	double	fa, fb, p, y;

	fa = (*f)(a);
	fb = (*f)(b);
	while (n--) {
		if (fa*fb > 0.0) {
			errno = ECANTBRACKET;
			return FAIL;
		}
		*x = (fa==fb ?  a : (a*fb-b*fa)/(fb-fa));
		y = (*f)(*x);
		if ((p=y*fb) > e)
			fa *= 0.5;
		else if (p < -e) {
			a = b;
			fa = fb;
		}
		else
			return SUCCEED;
		b = *x;
		fb = y;
	}
	return FAIL;
}
