/*
 * Generate a submatrix[newrl..newrl+(rh-rl)][newcl..newcl+(ch-cl)]
 * of a float matrix a[rl..rh][cl..ch]
 */

char	*emalloc();

/*ARGSUSED*/
float**
fsubmatrix(a, rl, rh, cl, ch, newrl, newcl)
	float	**a;	/* Original matrix[rl..rh][cl..ch]		*/
	int	rl, rh;
	int	cl, ch;
	int	newrl,
		newcl;
{
	int	i, j;	/* Dummy loop indices				*/
	float	**m;	/* Allocated array of row pointers		*/

	/* Allocate space for pointers to rows */
	m = (float**)emalloc((unsigned)(rh-rl+1)*sizeof(float*)) - newrl;

	/* Set pointers to rows */
	for (i=rl,j=newrl; i<=rh; i++,j++)
		m[j] = a[j] + cl - newcl;

	return m;
}

/*
 * Free a submatrix allocated by fsubmatrix()
 */
/*ARGSUSED*/
void
free_fsubmatrix(b, rl, rh, cl, ch)
	float	**b;
	int	rl, rh;
	int	cl, ch;
{
	free((char*)(b+rl));
}
