#ifndef lint
static char rcsid[]="$Header: geocen.c,v 1.1 90/11/05 22:20:15 julian Exp $";
#endif
/*
 * Calculate geocentric postitions, distances, and azimuths
 */
#include <math.h>
#include <local/mathconst.h>
#include <local/stdtyp.h>

void	cvrpd();

static double st0, ct0, phi0;

/*
 * Store reference point
 */
void
refpt(lat, lon)
	double	lat, lon;
{
	st0 = cos(lat);
	ct0 = sin(lat);
	phi0 = lon;
}

/*
 * Calculate distance, azimuths
 */
void
delaz(lat, lon, delta, az0, az1)
	double	lat, lon;
	double	*delta;
	double	*az0, *az1;
{
	double	st1, ct1;
	double	sdlon, cdlon;
	double	sdelt, cdelt;

	ct1 = sin(lat);
	st1 = cos(lat);
	sdlon = sin(lon - phi0);
	cdlon = cos(lon - phi0);
	cdelt = st0*st1*cdlon + ct0*ct1;
	cvrpd(st0*ct1-st1*ct0*cdlon, st1*sdlon, &sdelt, az0);
	*delta = atan2(sdelt, cdelt);
	cvrpd(st1*ct0-st0*ct1*cdlon, -sdlon*st0, &sdelt, az1);
	if (*az0 < 0.0)
		*az0 += TWOPI;
	if (*az1 < 0.0)
		*az1 += TWOPI;
}

/*
 * Determine second point
 */
void
back(delta, az0, lat, lon)
	double	delta, az0;
	double	*lat, *lon;
{
	double	sdelt, cdelt;
	double	dlon;
	double	cz0, ct1, st1;

	sdelt = sin(delta);
	cdelt = cos(delta);
	cz0 = cos(az0);
	ct1 = st0*sdelt*cz0 + ct0*cdelt;
	cvrpd(st0*cdelt-ct0*sdelt*cz0, sdelt*sin(az0), &st1, &dlon);
	*lat = atan2(ct1, st1);
	*lon = phi0 + dlon;
	if (fabs(*lon) > PI)
		*lon -= (*lon>0. ? TWOPI : -TWOPI);
}
