#ifndef lint
static char rcsid[] = "$Header: hunt.c,v 1.1 89/09/21 11:47:33 julian Exp $";
#endif lint
#include <stdio.h>
#include <assert.h>
#define bool int

	void	exit();		/* -lc					*/

/*
 * Find value within ordered array
 * After Press et al., Numerical Recipes in C, Section 3.4
 */
int
hunt(xx, n, x, jlo)
	float	xx[];		/* Array[1..n] to search		*/
	int	n;
	float	x;		/* Value sought				*/
	int	jlo;		/* Input guess				*/
{
	bool	ascend = (xx[n] > xx[1]);
	int	jhi, jm;
	int	inc;		/* Hunting increment			*/

	if (jlo < 1 || jlo > n) {
		/* Input guess not useful */
		jlo = 0;
		jhi = n+1;
	} else {
		inc = 1;
		if ((x >= xx[jlo]) == ascend) {
			/* Hunt up */
			if (jlo == n)
				return n;
			jhi = jlo + 1;
			while ((x >= xx[jhi]) == ascend) {
				jlo = jhi;
				inc += inc;
				jhi = jlo + inc;
				if (jhi > n) {
					/* Off end of table */
					jhi = n + 1;
					break;
				}
			}
		} else {
			/* Hunt down */
			if (jlo == 1)
				return 0;
			jhi = jlo;
			--jlo;
			while ((x < xx[jlo]) == ascend) {
				jhi = jlo;
				inc += inc;
				jlo = jhi - inc;
				if (jlo < 1) {
					/* Off end of table */
					jlo = 0;
					break;
				}
			}
		}

		/* Done hunting:  value bracketed */
		assert(jlo == 0   || (x >= xx[jlo]) == ascend);
		assert(jhi == n+1 || (x <= xx[jhi]) == ascend);
	}

	/* Bisection */
	while (jhi-jlo != 1) {
		jm = (jhi+jlo) >> 1;
		if ((x > xx[jm]) == ascend)	jlo = jm;
		else				jhi = jm;
	}
	return jlo;
}
