#ifndef lint
static char rcsid[] = "$Header$";
#endif lint
#ifdef DOUBLE
#define float double
#define fvector dvector
#define free_fvector free_dvector
#endif DOUBLE

	float	*fvector();
	void	free_fvector();

/*
 * Modified midpoint step
 */
void
mmid(y, dydx, n, xs, htot, nstep, yout, derivs)
	float	y[];		/* [1..n] Dependent variables		*/
	float	dydx[];		/* [1..n] Derivatives			*/
	int	n;		/* No. of dependent variables		*/
	float	xs;		/* Dependent variable			*/
	float	htot;		/* Total step size to use		*/
	float	yout[];		/* [1..n] Answer (may overlay y[])	*/
	void	(*derivs)();	/* User-supplied RHS function		*/
	int	nstep;		/* No. of sub-steps to use		*/
{
	int	s;		/* Step counter				*/
	int	i;
	float	x;
	float	swap;
	float	h2;
	float	h;
	float	*ym;
	float	*yn;

	ym = fvector(1, n);
	yn = fvector(1, n);
	h = htot/nstep;

	/* First step */
	for (i=1; i<=n; i++) {
		ym[i] = y[i];
		yn[i] = y[i] + h*dydx[i];
	}
	x = xs + h;
	(*derivs)(x, yn, yout);
	h2 = 2.0*h;

	/* General step */
	for (s=2; s<=nstep; s++) {
		for (i=1; i<=n; i++) {
			swap = ym[i] + h2*yout[i];
			ym[i] = yn[i];
			yn[i] = swap;
		}
		x += h;
		(*derivs)(x, yn, yout);
	}

	/* Last step */
	for (i=1; i<=n; i++)
		yout[i] = 0.5*(ym[i] + yn[i] + h*yout[i]);
	free_fvector(yn, 1, n);
	free_fvector(ym, 1, n);
}
