#ifndef lint
static char rcsid[]="$Header: prax.c,v 1.2 90/06/25 20:46:58 julian Exp $";
#endif
/*
 * Calculate principal axes of second-rank symmetric tensor
 * Bruce R. Julian, USGS Menlo Park, CA.  28 Jan 1986
 */

#include <local/mathconst.h>

void	cvctos();
float	**fmatrix();
void	free_fmatrix();
void	jacobi();

prax(tensor, pval, t, p)
	float	tensor[6];	/* Tensor (symmetric storage mode)	*/
	float	*pval;		/* [0..2] Principal values		*/
	float	*t, *p;		/* [0..2] Polar, azimuthal angles	*/
				/*    of principal axes			*/
{
	float	**a;		/* Scratch: [1..3][1..3]		*/
	float	**u;		/* Eigenvectors: [1..3][1..3]		*/
	float	r;		/* Scratch				*/
	int	i, j;		/* Dummy loop indices			*/
	int	nrot;		/* Number of Jacobi rotations (unused)	*/

	/* Calculate eigenvalues and eigenvectors of tensor */
	a = fmatrix(1, 3, 1, 3);
	u = fmatrix(1, 3, 1, 3);
	a[1][1] = tensor[0];
	a[2][2] = tensor[2];
	a[3][3] = tensor[5];
	a[1][2] = a[2][1] = tensor[1];
	a[1][3] = a[3][1] = tensor[3];
	a[2][3] = a[3][2] = tensor[4];
	jacobi(a, 3, pval-1, u, &nrot);
	eigsrt(pval-1, u, 3);

	/* Convert to principal values and angles of principal axes */
	for (j=1; j<=3; ++j) {
		/* Ensure that t[j] <= PI/2 */
		if (u[3][j] < 0.0)
			for (i=1; i<=3; ++i)
				u[i][j] *= -1.0;

		/* Convert direction cosines to angles */
		cvctos(u[1][j], u[2][j], u[3][j], &r, &t[j-1], &p[j-1]);
	}
	free_fmatrix(a, 1, 3, 1, 3);
	free_fmatrix(u, 1, 3, 1, 3);
}
