#ifndef lint
static char rcsid[]="$Header: station.c,v 1.3 88/10/17 11:18:34 julian Exp $";
#endif
/*
 * Functions to look up seismograph station info.
 */

#include <stdio.h>
#include <local/mathconst.h>
#include <local/quake.h>
#include <local/station.h>

char	*malloc();
int     strncmp();
char    *strncpy();
char    *bsearch();

/* Open station table */
STABLE *
stopen(filnam)
        char            *filnam;
{
        STABLE  *t;

        /* Get space for STABLE structure */
        t = (STABLE *)malloc((unsigned)sizeof(STABLE));
	if (t == NULL)
		return NULL;

        /* Open station-code table */
        t->fp = fopen(filnam, "r");
	if (t->fp == NULL)
		return NULL;

        /* Read in station count, station codes */
        if (fread((char *)&(t->nsta), sizeof(t->nsta), 1, t->fp) == 0)
		return NULL;
        t->idsta = malloc((unsigned)CSIZE*(t->nsta));
	if (t->idsta == NULL)
		return NULL;
        if (fread(t->idsta, (int)(CSIZE*(t->nsta)), 1, t->fp)    == 0)
		return NULL;

        /* Remember current position in file */
        t->offset = ftell(t->fp);
        return t;
}

/* Close station table */
void
stclose(t)
        STABLE *t;
{
        (void)fclose(t->fp);
        free(t->idsta);
        free((char *)t);
}

/* Comparison function for station codes */
static int
stacmp(a, b)
        register
	char		*a, *b;
{
	register
	char		*end=a+CSIZE;

	while (a < end) {
		if (*a != *b)
			return *a - *b;
		++a;
		++b;
	}
	return 0;
}

/* Find position of station in table */
int
stindex(t, sta)
        STABLE  *t;
        char    sta[CSIZE];     /* Desired station              */
{
        char *p;

        p = bsearch(sta, t->idsta, (unsigned)t->nsta, CSIZE, stacmp);
        return (p==NULL ? FAIL : (p - t->idsta)/CSIZE);
}

/* Retrieve station info. */
int
stget(t, i, ip)
        STABLE  *t;
        int     i;      /* Station index                (input) */
        STINFO  *ip;
{
	/* Copy station code into STINFO */
	(void)strncpy(ip->code, t->idsta+CSIZE*i, CSIZE);

        /* Position file to info for desired station */
        if (fseek(t->fp, (long)(t->offset+(sizeof(*ip)-CSIZE)*i), 0) == FAIL)
                return FAIL;

        /* Read station info. into STINFO */
        if (fread((char *)&(ip->lat), sizeof(*ip)-CSIZE, 1, t->fp) == 0)
                return FAIL;

	ip->lat *= RAD/60.;
	ip->lon *= RAD/60.;
        return SUCCEED;
}
