#ifndef lint
static char rcsid[] = "$Header: station_.c,v 1.4 88/10/17 11:18:37 julian Exp $";
#endif
/*
 * f77 interfaces to stopen(), stclose(), stindex(), and stget()
 */

#include <errno.h>
#include <stdio.h>
#include <local/f77types.h>
#include <local/quake.h>
#include <local/station.h>

#define MAXTABLES	5	/* No. of station tables open at once */

char	*strncpy();

static STABLE	*t[MAXTABLES] = { NULL, NULL, NULL, NULL, NULL };

/* Open station table */
/*ARGSUSED*/
F77INT
stopen_(filnam, l)
	char		*filnam;
	F77SLARG	l;
{
	extern int	errno;
	int		i;
	char		scratch[1024];

	/* Copy filnam to scratch, adding NULL terminator */
	for (i=0; i<sizeof(scratch); ++i) {
		if (filnam[i] == ' ')
			goto OK;
		scratch[i] = filnam[i];
	}
	errno = ENAMETOOLONG;
	return FAIL;
OK:
	scratch[i] = '\0';

	for (i=0; i<MAXTABLES; ++i)
		if (t[i] == NULL) {
			t[i] = stopen(scratch);
			if (t[i] == NULL)
				return FAIL;
			return i;
		}
	return FAIL;
}

/* Close station table */
void
stclos_(i)
	F77INT		*i;
{
	stclose(t[*i]);
	t[*i] = NULL;
}

/* Find position of station in table */
/*ARGSUSED*/
F77INT
stindx_(i, code, l)
	F77INT		*i;
	char		*code;
	F77SLARG	l;
{
	extern int errno;

	errno = 0;
	return stindex(t[*i], code);
}

/*::/* Look up station, return info. */
/*::F77INT
/*::stget_(i, j, code, lat, lon, ielev, dly, fmgc, xmgc, klas, prr, calr)
/*::	F77INT		*i;		/* Table id */
/*::	F77INT		*j;		/* Station index */
/*::	char		code[CSIZE];
/*::	float		*lat;
/*::	float		*lon;
/*::	F77INT		*ielev;
/*::	float		*dly;
/*::	float		*fmgc, *xmgc;
/*::	int		*klas;
/*::	float		*prr;
/*::	float		*calr;
/*::{
/*::	STINFO		s;
/*::
/*::	if (stget(t[*i], *j, &s) != SUCCEED)
/*::		return FAIL;
/*::	(void)strncpy(code, s.code, CSIZE);
/*::	*lat = s.lat;
/*::	*lon = s.lon;
/*::	*ielev = s.ielev;
/*::	*dly = s.dly;
/*::	*fmgc = s.fmgc;
/*::	*xmgc = s.xmgc;
/*::	*klas = s.klas;
/*::	*prr = s.prr;
/*::	*calr = s.calr;
/*::	return SUCCEED;
/*::}
::*/
