#ifndef lint
static char rcsid[]="$Header: time.c,v 1.2 88/10/17 13:56:48 julian Exp $";
#endif
/*
 * Computations based on date and time of day
 * Bruce R. Julian, USGS Menlo Park, CA
 */
#include <math.h>
#include <local/local.h>
#include <local/date_time.h>

/* Convert date and time to TIME variable */
TIME
timvar(yr, mo, da, hr, mn, sec, caltyp)
	int	yr, mo, da, hr, mn;
	double	sec;
	int	caltyp;
{
	return (double)DAY*(jdn(yr, mo, da, caltyp)-BASEJDN) +
		HOUR*hr + MINUTE*mn + SECOND*sec;
}

/* Convert TIME variable to date and time */
void
datime(t, pyr, pmo, pda, phr, pmn, psec, caltyp)
	TIME	t;
	int	*pyr, *pmo, *pda, *phr, *pmn;
	double	*psec;
	int	caltyp;
{
	long	d;

	d = floor(t/DAY);
	date(d+BASEJDN, pyr, pmo, pda, caltyp);
	t -= d*DAY;
	*phr = t/HOUR;
	t -= (*phr)*HOUR;
	*pmn = t/MINUTE;
	*psec = t - (*pmn)*MINUTE;
}
