/*
 * Structure of PCQL trace file
 */

typedef struct {
	char	acode;		/* Array code				*/
	char	tform[3];	/* Trace-file format			*/
	short	yr;		/* Year modulo 100			*/
	short	day;		/* Day of year				*/
	short	hr;		/* Hour					*/
	short	mn;		/* Minute				*/
	short	sec;		/* Trigger time (seconds)		*/
	short	ms;		/* Trigger time (milliseconds)		*/
	short	nprior;		/* No. of samples before trigger time	*/
	short	npts;		/* Total no. of samples per trace	*/
	short	nchan;		/* No. of channels			*/
	short	srate1;		/* Sampling rate (Hz)			*/
	short	srate2;		/* Sampling rate (mHz)			*/
	short	pad[51];
} HDR1;

typedef struct {
	short	chnum;		/* Channel number			*/
	short	mintr;
	short	maxtr;
	short	pad[61];
} HDR2;
