.TH PCQL2AH 1
.SH NAME
.BR pcql2ah
\- Convert PCQL seismic data trace files to AH format
.SH SYNTAX
.B pcql2ah
.RI [ option ...]
.RI [ trace_file ...]
.SH DESCRIPTION
.PP
.B pcql2ah
reads digital seismic data
from the specified PCQL (UNOCAL Corporation)
.IR trace_file s
(standard input default),
converts them to the XDR (External Data Representation) version
of Lamont's AH (AdHoc) format,
and writes them to its standard output.
Because the output is binary,
it must be directed to a file, device, or pipe,
and not sent to a terminal.
.SH OPTIONS
.PP
The following command-line options are used to control
.BR pcql2ah .
Options are scanned from left to right;
if conflicting options are given, the rightmost one takes precedence.
Only enough characters need be given to uniquely identify an option.
.TP
\fB-help\fR [\fIoption\fR...]
Print brief explanations of the specified
.IR option s.
If no
.IR option s
are named, explanations are printed for all
.IR option s.
The explanations are written to the standard error output.
.TP
\fB-stafile\fR \fIfile\fR
Use the specified PCQL station
.IR file ,
instead of the default.
The station file is used
only to map channel numbers and dates
into station and component codes;
the station coordinates are not copied to the AH header.
Since there are different station files for each network,
you must specify the station file -- there is no default station file.
.TP
\fB-ahtype float|short\fR
Specify the output datatype for the AH data.
The \fBshort\fR datatype specifies short (16-bit) integers, and is a USGS
extention to Lamont's AH format.
The default datatype is \fBfloat\fR.
.SH FILES
.B /data/dc1/unocal/parameters/f.stn - station file for "F" net.
.br
.B /data/dc1/unocal/parameters/g.stn - station file for "G" net.
.br
.B /data/dc1/unocal/parameters/w.stn - station file for "W" net.

.SH SEE ALSO
.BR pql (1)
\- program to examine AH-format digital data.
.br
.BR epick (1)
\- program to measure times, amplitudes, etc. from AH-format digital data.
.SH EXAMPLES
.PP
To convert the PCQL file
.B 1090085b.g91
to AH format and store the result in the file
.BR 1090085b.g91.ah ,
use the command
.IP
.B pcql2ah -stafile /data/dc1/unocal/parameters/g.stn 1090085b.g91 > 1090085b.g91.ah
.SH AUTHOR
Bruce R. Julian USGS, Menlo Park, Calif., August 1992
