/* Variables that control testing */
#ifdef ALLOC_EXTERN
#define	EXTERN
#else
#define	EXTERN	extern
#endif

#define MAXVERT		50		/* No. of vertices of polygon	*/

EXTERN	bool	do_lat,			/* Which tests to do	*/
		do_lon,
		do_depth,
		do_otime,
		do_mag,
		do_mag_obs,
		do_ml_obs,
		do_mw_obs,
		do_m0,
		do_m0_obs,
		do_felt,
		do_close,
		do_nsta,
		do_rms,
		do_oterr,
		do_laterr,
		do_lonerr,
		do_horerr,
		do_deperr,
		do_gap,
		do_qual,
		do_etype,
		do_delta,
		do_poly;

EXTERN bool	search_catalog;		/* Search catalog.	*/
EXTERN bool	verbose;		/* Verbose information.	*/
EXTERN bool	negate;			/* Reverse sense of test*/
EXTERN char	*quals;			/* Quality codes	*/
EXTERN char	*etypes;		/* Event types		*/
EXTERN char 	felt;			/* felt events 		*/
EXTERN double	clomin, clomax;		/* Closest station	*/
EXTERN double	gapmin, gapmax;		/* Gap			*/
EXTERN double	latmin, latmax;		/* Latitude 		*/
EXTERN double	lonmin, lonmax;		/* Longitude 		*/
EXTERN double	magmin, magmax;		/* Magnitude		*/
EXTERN double	mlmin,	mlmax;		/* ML 			*/
EXTERN double 	mwmin,	mwmax;		/* Mw			*/
EXTERN double 	m0min,	m0max;		/* scalar moment 	*/
EXTERN int	nstmin, nstmax;		/* No. of stations	*/
EXTERN double	rmsmin, rmsmax;		/* RMS residual		*/
EXTERN TIME	otmin,  otmax;		/* Origin time		*/
EXTERN double	delmin, delmax;		/* Epicentral distance	*/
EXTERN double	plat[MAXVERT+1],	/* Vertices of polygon	*/
		plon[MAXVERT+1];
EXTERN int	nvert;			/* No. of vertices	*/
EXTERN double	zmin, zmax;		/* Focal depth		*/
EXTERN int	nmagmin, nmagmax;	/* number of sta in mag	*/
EXTERN int	nm0min,	nm0max;		/* nsta in m0 calc	*/
EXTERN double	otemin,	otemax;		/* origin time error	*/
EXTERN double	laemin,	laemax;		/* latitude error	*/
EXTERN double	loemin,	loemax;		/* longitude error	*/
EXTERN double	herrmin, herrmax;	/* horizontal error	*/
EXTERN double	zerrmin, zerrmax;	/* depth error		*/
EXTERN double 	semin,	semax;		/* standard error	*/
EXTERN double	ct0, st0, phi0;		/* Ref. pt. for delta	*/
EXTERN double	cdmin, cdmax;		/* cos(delmin), cos(delmax)	*/
EXTERN int     	input_format;		/* input format type.	*/

#define MAXMAGTYPES	8		/* Max # of mag types.	*/

/* Types of magnitudes for searches */
#define	ML_MAG		1
#define	MML_MAG		2
#define CODA_MAG	4
#define	AMP_MAG		8
#define	AVG_MAG		16
#define	MLN_MAG		32
#define	BM_MAG		64
#define MW_MAG		128

#define CALNET_CATLOG_MAGS	( ML_MAG | MML_MAG | CODA_MAG | AMP_MAG | AVG_MAG )
#define UCB_CATALOG_MAGS	( ML_MAG | MLN_MAG | BM_MAG | MW_MAG )
#define CALNET_MECH_MAGS	( AVG_MAG )

/* Structure for magnitude searches. */
typedef struct _mags {			/* magnitude search structure	*/
    int	nprefs;				/* # of mag types for search	*/
    int magtype[MAXMAGTYPES];		/* mag types to search in order	*/
} MAGS;

EXTERN	MAGS	mags;

