#include <stdio.h>

void clear_old_data(int num_enteries,char **ent_list) {
  int i;

  for (i=0;i<=num_enteries;i++) {
    free(ent_list++);
  }
}

void print_stuff(int num_enteries,char **ent_list) {
  int i;

  for (i=0;i<num_enteries;i++) {
    printf("%s",*(ent_list++));
  }
  printf("$end\n");
}

void main (void) {
  int num_line;
  char **s_line;
  char temp_line[500];
  char *new_line;
  char card[5];
  FILE *in_data;

  in_data=fopen("test.data","r");
  if (in_data==NULL) {
    fprintf (stderr,"can not open data file\n");
    exit(-1);
  }

  while (fgets(temp_line,500,in_data)!=NULL) {
    strncpy(card,temp_line,4);
    card[4]='\0';

    if (!strcmp(card,"$end")) {
      /* print if matching event */
      if ((failed_evt && negate)||(!failed_evt && !negate)) { 
	print_stuff(num_line,s_line);
      }
      clear_old_data(num_line,s_line);
      num_line=0;
      failed_evt=0;
    } else {
      /* if the event has not yet failed to meet */
      /* criteria try matching next line of evt  */
      if (!failed_evt) {
	/* now do the search stuff */
	if (!strcmp(card,"$loc") ) {
	  if (temp_line[] ==`P`) {
	    search=1;
	  }
	  /* do the loc line search*/
	  if (search=1) {

	    if (do_otime) {		/* ORIGIN TIME */
	      yr = DECODE(line+YEAR_OFFSET, YEAR_LEN, atoi);
	      mo = DECODE(line+MONTH_OFFSET, MONTH_LEN, atoi);
	      da = DECODE(line+DAY_OFFSET, DAY_LEN, atoi);
	      
	      hr = DECODE(line+HOUR_OFFSET, HOUR_LEN, atoi);
	      mn = DECODE(line+MINUTE_OFFSET, MINUTE_LEN, atoi);
	      se = DECODE(line+SECOND_OFFSET, SECOND_LEN, atof);
	      ot = timvar(yr, mo, da, hr, mn, se, GREGORIAN);
	      if (ot < otmin || ot > otmax)
	      failed_evt=1;
	      
	    }
	    if (do_lat) {		/* LATITUDE */
	      lat = DECODE(line+LAT_OFFSET, LAT_LEN, atof);
	      if (lat < latmin || latmax < lat) failed_evt=1;	      
	    }
	    if (do_lon) {		/* LONGITUDE */
	      lon = DECODE(line+LON_OFFSET, LON_LEN, atof);
	      if (lon < lonmin || lonmax < lon) failed_evt=1;      
	    }
	    if (do_depth) {		/* FOCAL DEPTH */
	      depth = (linelen < DEPTH_OFFSET+DEPTH_LEN) ? no_depth :
		DDECODE (line+DEPTH_OFFSET, DEPTH_LEN, atof, no_depth);
	      if (depth < zmin || zmax < depth) failed_evt=1;
	    }
	    if (do_nsta) {		/* NUMBER OF STATIONS (PHASES for CNSS)*/
	      num_sta = (linelen < NPH_LOC_OFFSET+NPH_LOC_LEN) ? no_num_sta :
		DDECODE (line+NPH_LOC_OFFSET, NPH_LOC_LEN, atoi, no_num_sta);
	      if (num_sta < nstmin || nstmax < num_sta) failed_evt=1;	      
	    }
	    if (do_rms) {		/* RMS RESIDUAL */
	      rms = (linelen < RMS_OFFSET+RMS_LEN) ? no_rms :
		DDECODE(line+RMS_OFFSET, RMS_LEN, atof, no_rms);
	      if (rms < rmsmin || rmsmax < rms) failed_evt=1;	      
	    }
	    if (do_gap) {		/* AZIMUTHAL GAP */
	      max_az_gap = (linelen < AZ_GAP_OFFSET+AZ_GAP_LEN) ? no_max_az_gap : 
		DDECODE (line+AZ_GAP_OFFSET, AZ_GAP_LEN, atoi, no_max_az_gap);
	      if (max_az_gap < gapmin || gapmax < max_az_gap) failed_evt=1;
	    }
	    if (do_close) {		/* DISTANCE TO CLOSEST STATION */
	      close = (linelen < DIST_OFFSET+DIST_LEN) ? no_close :
		DDECODE(line+DIST_OFFSET, DIST_LEN, atof, no_close);
	      if (close < clomin || clomax < close) failed_evt=1;
	    }
	    if (do_oterr) {		/* ERROR IN ORIGIN TIME */
	      otime_err = (linelen < DIST_OFFSET+DIST_LEN) ? no_otime_err :
		DDECODE(line+OT_ERR_OFFSET, OT_ERR_LEN, atof, no_otime_err);
	      if (otime_err < otemin || otime_err > otemax) failed_evt=1;
	    }
	    if (do_laterr) {	/* ERROR IN LATITUDE */
	      lat_err = (linelen < DIST_OFFSET+DIST_LEN) ? no_lat_err :
		DDECODE(line+LAT_ERR_OFFSET, LAT_ERR_LEN, atof, no_lat_err);
	      if (lat_err < laemin || lat_err > laemax) failed_evt=1;
	    }
	    if (do_lonerr) {	/* ERROR IN LONGITUDE */
	      lon_err = (linelen < DIST_OFFSET+DIST_LEN) ? no_lon_err :
		DDECODE(line+LON_ERR_OFFSET, LON_ERR_LEN, atof, no_lon_err);
	      if (lon_err < loemin || lon_err > loemax) failed_evt=1;
	    }
	    if (do_deperr) {	/* ERROR IN DEPTH */
	      depth_err = (linelen < DIST_OFFSET+DIST_LEN) ? no_depth_err :
		DDECODE(line+DEPTH_ERR_OFFSET, DEPTH_ERR_LEN, atof, no_depth_err);
	      if (depth_err < zerrmin || depth_err > zerrmax) failed_evt=1;
	    }
	    if (do_poly) {		/* POLYGONAL REGION */
	      /* Note: do_poly implies do_lat and do_lon */
	      if (inpoly(lat, lon, plat, plon, nvert) == 0) failed_evt=1;
	    }
	    if (do_delta) {		/* EPICENTRAL DISTANCE */
	      /* Note: do_delta implies do_lat and do_lon */
	      lat = ggtogc(RAD*lat);
	      ct1 = sin(lat);
	      st1 = cos(lat);
	      cdlon = cos(RAD*lon - phi0);
	      cdelt = st0*st1*cdlon + ct0*ct1;
	      if (cdelt > cdmin || cdelt < cdmax) failed_evt=1;
	      /* sdlon = sin(lon - phi0);					*/
	      /* cvrpd(st0*ct1-st1*ct0*cdlon, st1*sdlon, &sdelt, az0);	*/
	      /* *delta = atan2(sdelt, cdelt);				*/
	      /* cvrpd(st1*ct0-st0*ct1*cdlon, -sdlon*st0, &sdelt, az1);	*/
	    }

	  }

	} else if (!strcmp(card,"$mag")) {
	  if (temp_line[] ==`P`) {
	    search=1;
	  }
	  if (search==1) {
	    /* do the mag line search */
	    if (do_mag) {		/* MAG */
	      mag =  (linelen < MAG_OFFSET+MAG_LEN) ? no_mag :
		DDECODE (line+MAG_OFFSET, MAG_LEN, atof, no_mag);
	      if (mag < magmin || magmax < mag) failed_evt=1;
	    }
	    if (do_mag_obs) {	/* NUMBER OF OBSERVATIONS USED TO GET MAG */
	      num_mag_obs = (linelen < DIST_OFFSET+DIST_LEN) ? no_num_mag_obs :
		DDECODE(line+N_MAG_OFFSET, N_MAG_LEN, atoi, no_num_mag_obs);
	      if (num_mag_obs < nmagmin || nmagmax < num_mag_obs) failed_evt=1;
	    }
	    
	  }
	}

	if (!failed_evt || (failed_evt && negate) ){
	  /* store the line if the event is okay */
	  ++num_line;
	  new_line=(char *)malloc(strlen(temp_line)+1);
	  strcpy(new_line,temp_line);
	  if (num_line==1) {
	    s_line=(char **)malloc(sizeof(char*));
	  } else {
	    s_line=(char **)realloc (s_line,sizeof(char*)*num_line);
	  }
	  s_line[num_line-1]=new_line;
	}
	  
      }
    }

  }

}

