/*	Format info for UCB catalog.	*/

#define MAXUCBLINE      200
#define MAXCOMMENTS	20

/*	Year		*/
#define YEAR_COL	1
#define	YEAR_OFFSET	YEAR_COL-1
#define YEAR_LEN	4

/*	Month		*/
#define	MONTH_COL	5
#define	MONTH_OFFSET	MONTH_COL-1
#define MONTH_LEN	2

/*	Day		*/
#define	DAY_COL		7
#define DAY_OFFSET	DAY_COL-1
#define	DAY_LEN		2

/*	Hour		*/
#define HOUR_COL	10
#define HOUR_OFFSET	HOUR_COL-1
#define	HOUR_LEN	2

/*	Minute		*/
#define MINUTE_COL	12
#define MINUTE_OFFSET	MINUTE_COL-1
#define	MINUTE_LEN	2

/*	Second		*/
#define SECOND_COL	14
#define SECOND_OFFSET	SECOND_COL-1
#define	SECOND_LEN	7

/*	Latitude	*/
#define LAT_COL		22
#define LAT_OFFSET	LAT_COL-1
#define	LAT_LEN		8

/*	Longitude	*/
#define LON_COL		31
#define	LON_OFFSET LON_COL-1
#define LON_LEN		9

/*	Depth		*/
#define	DEPTH_COL	41
#define	DEPTH_OFFSET	DEPTH_COL-1
#define	DEPTH_LEN	8

/*	Benioff Magnitude	*/
#define	BM_MAG_COL	50
#define	BM_MAG_OFFSET	BM_MAG_COL-1
#define BM_MAG_LEN	4

/*	# observations used to get Benioff Magnitude	*/
#define N_BM_MAG_COL	55
#define	N_BM_MAG_OFFSET	N_BM_MAG_COL-1
#define	N_BM_MAG_LEN    3

/*	ML Magnitude - traditional (computed from ARC, BKS, MHC, MIN)	*/
#define	ML_COL		59
#define	ML_OFFSET	ML_COL-1
#define	ML_LEN		4

/*	# observations used to get ML Magnitude	*/
#define N_ML_COL	64
#define N_ML_OFFSET	N_ML_COL-1
#define N_ML_LEN	3

/*	Network ML Magnitude - computed from all stations in network.	*/
#define	MLN_COL		68
#define	MLN_OFFSET	MLN_COL-1
#define	MLN_LEN		4

/*	# observations used to get Network ML Magnitude	*/
#define N_MLN_COL	73
#define N_MLN_OFFSET	N_MLN_COL-1
#define N_MLN_LEN	3

/*	Moment Magnitude Mw	*/
#define MW_COL		77
#define MW_OFFSET	MW_COL-1
#define MW_LEN		4

/*	# observations used to get Momemt Magnitude Mw	*/
#define N_MW_COL	82
#define N_MW_OFFSET	N_MW_COL-1
#define N_MW_LEN	3

/*	Scalar Moment M0	*/
#define	M0_COL		86
#define	M0_OFFSET	M0_COL-1
#define	M0_LEN		9

/*	# observations used to get Scal Momemt M0	*/
#define	N_M0_COL	96
#define	N_M0_OFFSET	N_M0_COL-1
#define	N_M0_LEN	3

/*	# of stations used to locate the event.	*/
#define NSTA_COL	100
#define NSTA_OFFSET	NSTA_COL-1
#define NSTA_LEN	3

/*	Maximum azimuthal gap	*/
#define	AZ_GAP_COL	104
#define	AZ_GAP_OFFSET	AZ_GAP_COL-1
#define	AZ_GAP_LEN	3

/*	Minimum distance (delta) to nearest station.	*/
#define DIST_COL	108
#define DIST_OFFSET	DIST_COL-1
#define DIST_LEN	6

/*	Error in o-time in seconds.	0 -> no information	*/
#define	OT_ERR_COL	115
#define	OT_ERR_OFFSET	OT_ERR_COL-1
#define	OT_ERR_LEN	7

/*	Error in latitude (km).		0 -> no information	*/
#define	LAT_ERR_COL	123
#define	LAT_ERR_OFFSET	LAT_ERR_COL-1
#define	LAT_ERR_LEN	7

/*	Error in longitude (km).	0 -> no information	*/
#define LON_ERR_COL	131
#define LON_ERR_OFFSET	LON_ERR_COL-1
#define LON_ERR_LEN	7

/*	Error in depth (km).		0 -> contrained depth	*/
#define DEPTH_ERR_COL	139
#define DEPTH_ERR_OFFSET	DEPTH_ERR_COL-1
#define DEPTH_ERR_LEN	7

/*	RMS value of the residuals.	0 -> no information	*/
#define RMS_COL		147
#define RMS_OFFSET	RMS_COL-1
#define RMS_LEN		7

/*	Qualtity flag.			"_" -> no information	*/
#define QUAL_COL	155
#define QUAL_OFFSET	QUAL_COL-1
#define QUAL_LEN	1

/*	Felt report.			"_" -> no information	*/
#define	FELT_COL	157
#define	FELT_OFFSET	FELT_COL-1
#define	FELT_LEN	1
