/*	Format info for CNSS catalog.	*/
/*	CNSS format definition.		*/

/************************************************************************/
/*  $loc record.							*/
/************************************************************************/

#define YEAR_COL	6
#define	YEAR_OFFSET	YEAR_COL-1
#define YEAR_LEN	4

#define	MONTH_COL	10
#define	MONTH_OFFSET	MONTH_COL-1
#define MONTH_LEN	2

#define	DAY_COL		12
#define DAY_OFFSET	DAY_COL-1
#define	DAY_LEN		2

#define HOUR_COL	14
#define HOUR_OFFSET	HOUR_COL-1
#define	HOUR_LEN	2

#define MINUTE_COL	16
#define MINUTE_OFFSET	MINUTE_COL-1
#define	MINUTE_LEN	2

#define SECOND_COL	18
#define SECOND_OFFSET	SECOND_COL-1
#define	SECOND_LEN	7

/*	Latitude	*/
#define LAT_COL		25
#define LAT_OFFSET	LAT_COL-1
#define	LAT_LEN		9

/*	Longitude	*/
#define LON_COL		34
#define	LON_OFFSET LON_COL-1
#define LON_LEN		10

#define	DEPTH_COL	44
#define	DEPTH_OFFSET	DEPTH_COL-1
#define	DEPTH_LEN	8

#define	LOC_TYPE_COL	52
#define	LOC_TYPE_OFFSET	LOC_TYPE_COL-1
#define	LOC_TYPE_LEN	2

#define	SRC_CODE_COL	54
#define	SRC_CODE_OFFSET	SRC_CODE_COL-1
#define	SRC_CODE_LEN	3

#define	NPH_LOC_COL	57
#define	NPH_LOC_OFFSET	NPH_LOC_COL-1
#define	NPH_LOC_LEN	4

#define	AZ_GAP_COL	61
#define	AZ_GAP_OFFSET	AZ_GAP_COL-1
#define	AZ_GAP_LEN	3

#define	DIST_COL	64
#define	DIST_OFFSET	DIST_COL-1
#define	DIST_LEN	10

#define	RMS_COL		74
#define	RMS_OFFSET	RMS_COL-1
#define	RMS_LEN		7

/*	Error in o-time in seconds.	0 -> no information	*/
#define	OT_ERR_COL	81
#define	OT_ERR_OFFSET	OT_ERR_COL-1
#define	OT_ERR_LEN	7

#define	HERR_COL	88
#define	HERR_OFFSET	HERR_COL-1
#define	HERR_LEN	7

#define	DEPTH_ERR_COL		95
#define	DEPTH_ERR_OFFSET	DEPTH_ERR_COL-1
#define	DEPTH_ERR_LEN		7

#define	REMARKS_COL	102
#define	REMARKS_OFFSET	REMARKS_COL-1
#define	REMARKS_LEN	2

/* Date location was computed.	*/
#define LYEAR_COL	104
#define	LYEAR_OFFSET	LYEAR_COL-1
#define LYEAR_LEN	4

#define	LMONTH_COL	108
#define	LMONTH_OFFSET	LMONTH_COL-1
#define LMONTH_LEN	2

#define	LDAY_COL	110
#define LDAY_OFFSET	LDAY_COL-1
#define	LDAY_LEN	2

#define	CNSS_ID_COL	112
#define CNSS_ID_OFFSET	CNSS_ID_COL-1
#define	CNSS_ID_LEN	12

#define	LOC_REC_LEN	123

/************************************************************************/
/*  $mag record								*/
/************************************************************************/

#define	MAG_REC_OFFSET	(LOC_REC_LEN + 1)

#define	MAG_COL		6+MAG_REC_OFFSET
#define	MAG_OFFSET	MAG_COL-1
#define	MAG_LEN		5

#define	MAG_TYPE_COL	11+MAG_REC_OFFSET
#define	MAG_TYPE_OFFSET	MAG_TYPE_COL-1
#define	MAG_TYPE_LEN	2

#define	MAG_SRC_COL	13+MAG_REC_OFFSET
#define	MAG_SRC_OFFSET	MAG_SRC_COL-1
#define	MAG_SRC_LEN	3

#define	N_MAG_COL	16+MAG_REC_OFFSET
#define	N_MAG_OFFSET	N_MAG_COL-1
#define	N_MAG_LEN	4

#define	MAG_ERR_COL	20+MAG_REC_OFFSET
#define	MAG_ERR_OFFSET	MAG_ERR_COL-1
#define	MAG_ERR_LEN	5

#define	TOT_MAG_WEIGHTS_COL	25+MAG_REC_OFFSET
#define	TOT_MAG_WEIGHTS_OFFSET	TOT_MAG_WEIGHTS_COL-1
#define	TOT_MAG_WEIGHTS_LEN	4

/* Date magnitude was computed.	*/
#define MYEAR_COL	29+MAG_REC_OFFSET
#define	MYEAR_OFFSET	MYEAR_COL-1
#define MYEAR_LEN	4

#define	MMONTH_COL	33+MAG_REC_OFFSET
#define	MMONTH_OFFSET	MMONTH_COL-1
#define MMONTH_LEN	2

#define	MDAY_COL	35+MAG_REC_OFFSET
#define MDAY_OFFSET	MDAY_COL-1
#define	MDAY_LEN	2

#define	CNSS_MAG_ID_COL		37+MAG_REC_OFFSET
#define CNSS_MAG_ID_OFFSET	CNSS_MAG_ID_COL-1
#define	CNSS_MAG_ID_LEN		12

#define	MAG_REC_LEN	48

/************************************************************************/
/*  $add$loc record.							*/
/************************************************************************/

#define	ADDLOC_REC_OFFSET (MAG_REC_OFFSET + MAG_REC_LEN + 1)

#define	NPS_COL		9+ADDLOC_REC_OFFSET
#define	NPS_OFFSET	NPS_COL-1
#define	NPS_LEN		4

#define	NS_COL		13+ADDLOC_REC_OFFSET
#define	NS_OFFSET	NS_COL-1
#define	NS_LEN		4

#define	NPFM_COL	17+ADDLOC_REC_OFFSET
#define	NPFM_OFFSET	NPFM_COL-1
#define	NPFM_LEN	4

#define	AZ_SPE_COL	21+ADDLOC_REC_OFFSET
#define	AZ_SPE_OFFSET	AZ_SPE_COL-1
#define	AZ_SPE_LEN	3

#define	DIP_SPE_COL	24+ADDLOC_REC_OFFSET
#define	DIP_SPE_OFFSET	DIP_SPE_COL-1
#define	DIP_SPE_LEN	2

#define	MAG_SPE_COL	26+ADDLOC_REC_OFFSET
#define	MAG_SPE_OFFSET	MAG_SPE_COL-1
#define	MAG_SPE_LEN	10

#define	AZ_IPE		36+ADDLOC_REC_OFFSET
#define	AZ_IPE_OFFSET	AZ_IPE_COL-1
#define	AZ_IPE_LEN	3

#define	DIP_IPE_COL	39+ADDLOC_REC_OFFSET
#define	DIP_IPE_OFFSET	DIP_IPE_COL-1
#define	DIP_IPE_LEN	2

#define	MAG_IPE_COL	41+ADDLOC_REC_OFFSET
#define	MAG_IPE_OFFSET	MAG_IPE_COL-1
#define	MAG_IPE_LEN	10

#define	AZ_LPE		51+ADDLOC_REC_OFFSET
#define	AZ_LPE_OFFSET	AZ_LPE_COL-1
#define	AZ_LPE_LEN	3

#define	DIP_LPE_COL	53+ADDLOC_REC_OFFSET
#define	DIP_LPE_OFFSET	DIP_LPE_COL-1
#define	DIP_LPE_LEN	2

#define	MAG_LPE_COL	55+ADDLOC_REC_OFFSET
#define	MAG_LPE_OFFSET	MAG_LPE_COL-1
#define	MAG_LPE_LEN	4

/*	Error in latitude (km).		0 -> no information	*/
#define	LAT_ERR_COL	66+ADDLOC_REC_OFFSET
#define	LAT_ERR_OFFSET	LAT_ERR_COL-1
#define	LAT_ERR_LEN	10

/*	Error in longitude (km).	0 -> no information	*/
#define LON_ERR_COL	76+ADDLOC_REC_OFFSET
#define LON_ERR_OFFSET	LON_ERR_COL-1
#define LON_ERR_LEN	10

#define	LEVENTID_COL	86+ADDLOC_REC_OFFSET
#define	LEVENTID_OFFSET	LEVENTID_COL-1
#define	LEVENTID_LEN	12

#define	EVENTID_COL	98+ADDLOC_REC_OFFSET
#define	EVENTID_OFFSET	EVENTID_COL-1
#define	EVENTID_LEN	12


/************************************************************************/
