#ifndef lint
static char rcsid[] = "$Header: cvmsf.c,v 1.2 92/01/23 14:22:58 julian Exp $";
#endif lint
/*
 * Convert matrix from symmetric to full storage mode
 * Bruce R. Julian, USGS Menlo Park Calif., Dec 15 1983
 */

#ifdef DOUBLE
#define FLOAT	double
#define CVMSF	dcvmsf
#define COPY	dcopy
#else DOUBLE
#define FLOAT	float
#define CVMSF	cvmsf
#define COPY	fcopy
#endif DOUBLE

#ifndef NODEBUG
#include <stdio.h>
#include <assert.h>
#endif NODEBUG

void	COPY();

/* Convert matrix from symmetric to full storage mode */
CVMSF(a, n, b, ib)
	FLOAT	*a, *b;		/* Source, target matrices (may share storage) */
	int	n, ib;
{
	int	i;
#ifndef NDEBUG
	FLOAT	*aa=a, *bb=b;
#endif NODEBUG

	if (n <= 0)
		return;

	/* Copy values into lower trangle */
	a += (n*(n-1))/2;
	b += n*ib;
	i = n;
	while (i) {
		b -= ib;
		COPY(a, b, i);
		i--;
		a -= i;
	}
	/* a and b pointers are now restored to their original values */
	assert(a == aa);
	assert(b == bb);

	/* Copy values from lower into upper triangle */
	a = b;
	for (i=1; i<n; i++)
		COPY(a+=ib, ++b, i);
}
