#ifndef lint
static char rcsid[] = "$Header: ureduc.c,v 1.2 90/06/15 11:20:13 julian Exp $";
#endif lint
/*
 * Weighting to deal with noisy data
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */

#include <math.h>
#include <local/quake.h>

/* Evaluate weight for a single value  */
double
weight(val, mu, s)
	double	val;	/* Sample value					*/
	double	mu;	/* Relative frequency of bad data	(input) */
	double	s;	/* Spread				(input) */
{
	double	dm1;		/* Scratch variable  */
	double	x;

	if (mu == 0.0)
		return 1.0;
	if (s == 0.0)
		if (val == 0.0)
			dm1 = 0.0;
		else
			return 0.0;
	else {
		x = val/s;
		dm1 = 0.5*x*x;
	}
	return (dm1 <= 50.0 ? (1.0/(1.0 + mu*exp(dm1))) : 0.0);
}
