#ifndef lint
static char rcsid[] = "$Header: evdec.c,v 1.2 90/06/15 11:00:57 julian Exp $";
#endif lint
/*
 * Decode USGS-style summary card, put into origin structure
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */

#include <local/decode.h>
#include <local/mathconst.h>
#include <local/quake.h>

char	*index(), *strncpy();
double	ggtogc();
double	atof();
int	atoi();

int
evdec(c, op)
	char	*c;		/* Phase card			(input) */
	ORIGIN	*op;		/* Origin structure		(output)*/
{
	int	year, month, day, hour, min;
	double	sec;
	double	d, m;

	/* Origin time */
	year	= DECODE(c+9 , 2, atoi);
	month	= DECODE(c+11, 2, atoi);
	day	= DECODE(c+13, 2, atoi);
	hour	= DECODE(c+16, 2, atoi);
	min	= DECODE(c+18, 2, atoi);
	sec	= DECODE(c+20, 6, atof);
	if (! HASDECPT)
		sec *= 0.01;
	op->o_time = timvar(1900+year, month, day, hour, min, sec, GREGORIAN);

	/* Hypocenter */
	d	= DECODE(c+27, 2, atof);
	m	= DECODE(c+30, 5, atof);
	op->o_lat = ggtogc(RAD*(d + m/60.));
	d	= DECODE(c+36, 3, atof);
	m	= DECODE(c+40, 5, atof);
	op->o_lon = -RAD*(d + m/60.);	/* Assume western hemisphere */
	op->o_depth = DECODE(c+47, 5, atof);

	return(0);
}
