#ifndef lint
static char rcsid[] = "$Header: cucof.c,v 1.1 89/02/07 09:32:05 julian Exp $";
#endif lint
/*
 * Generate coefficients for cubic interpolation
 */
void
cucof(f, f1, d, c)
	float	*f,		/* Vector[1..2] of function values	*/
		*f1;		/* Vector[1..2] of derivative values	*/
	float	d;		/* Grid spacing				*/
	float	*c;		/* Vector[0..3] of coefficients 	*/
{
static	double	t;		/* Scratch				*/

	/* Hard-coded transformation, to exploit sparsness */
	c[0] = f[1];
	c[1] = f1[1]*d;
	t = f[2] - f[1];
	c[3] = -(t + t) + c[1] + f1[2]*d;
	c[2] = -c[3] + t - c[1];
}

#ifdef TEST
main()
{
	float	c[4];
	float	f[2], f1[2];

	while (scanf("%f%f%f%f", f, f1, f+1, f1+1) == 4) {
		cucof(f-1, f1-1, 1.0, c);
		printf("%g\t%g\t%g\t%g\n", c[0],c[1],c[2],c[3]);
	}
}
#endif TEST
